﻿ ;; 
 ;; Gilles Chanteau, France
 ;; 2011
 ;; 
 ;; Extended data editing
 ;; 
 ;; Перевод на английский (АлексЮстасу) Google Translater
 ;; 
 ;; 
(defun c:xdedit_l	(/
	 ;; fonctions
	 writeDcl xdedit_lDlg
	 ;; variables
	 appName ent elst xdata)

 ;;-------------------------- sous-routines --------------------------;;

 ;; writeDcl
 ;; Ecrit le DCL dans un fichier temporaire en fonction des xdatas
 ;; Retourne une liste : (fichier liste_clés_text_box liste_clés_button)

 (defun writeDcl (/
	   ;; fonctions
	   writeTextBox	writeTextBoxAndButton
	   ;; variables
	   tmp file cnt	code tKeys bKeys tk bk)

   ;; writeTextBox
   (defun writeTextBox	(code key)
     (write-line
(strcat
  ":edit_box{label="
  (vl-prin1-to-string code)
  ";key="
  (vl-prin1-to-string key)
  ";allow_accept=true;}"
)
file
     )
   )

   ;; writeTextBoxAndButton
   (defun writeTextBoxAndButton (code tk bk)
     (write-line
(strcat
  ":row{:edit_box{label="
  (vl-prin1-to-string code)
  ";key="
  (vl-prin1-to-string tk)
  ";allow_accept=true;}"
  ":button{label=\">>\";width=4;fixed_width=true;key="
  (vl-prin1-to-string bk)
  ";}}"
)
file
     )
   )

   ;;-------------------------------------------------------------------;;

   (setq tmp  (vl-filename-mktemp "Tmp.dcl")
  file (open tmp "w")
  cnt  -1
   )
   (write-line
     (strcat
"xdedit_l:dialog{label=\"Extended data editing\";width=42;"
":text{label="
(vl-prin1-to-string (strcat "Registered application : " appName))
";}spacer;:boxed_column{label=\"Extended data\";"
     )
     file
   )
   (foreach x xdata
     (setq code (car x)
    cnt	 (1+ cnt)
     )
     (cond
((= 1002 code) (write-line (strcat ":text{label=\"1002     \\" (cdr x) "\";}") file))
((member code '(1000 1042 1070 1071))
 (setq tKeys (cons (setq tk (strcat (itoa cnt) "_txt_" (itoa code))) tKeys))
 (writeTextBox (itoa code) tk)
)
((member code '(1003 1005 1010 1011 1012 1013 1040 1041))
 (setq tKeys (cons (setq tk (strcat (itoa cnt) "_txt_" (itoa code))) tKeys)
       bKeys (cons (setq bk (strcat (itoa cnt) "_btn_" (itoa code))) bKeys)
 )
 (writeTextBoxAndButton (itoa code) tk bk)
)
     )
   )
   (write-line "}spacer;ok_cancel;}" file)
   (close file)
   (list tmp (reverse tKeys) (reverse bKeys))
 )

 ;;-------------------------------------------------------------------;;

 ;; xdedit_lDlg
 ;; Boite de dialogue de modification des xdatas
 ;; Retourne le résultat : 1 = OK, 0 = Annuler

 (defun xdedit_lDlg (/
	    ;; fonctions
	    xdSubst action
	    ;; variables
	    tmp	tKeys bKeys dcl_id status klst key keys	val)

   ;; xdSubst
   ;; Remplace la valeur dans la donnée étendue
   (defun xdSubst (key val / klst)
     (setq klst (gc:str2lst key "_"))
     (setq xdata (gc:substAt (cons (atoi (caddr klst)) val) (atoi (car klst)) xdata))
   )

   ;; action
   ;; change la donnée étendue ou retourne un message
   (defun action (key val msg / klst)
     (setq klst (gc:str2lst key "_"))
     (if val
(xdSubst key val)
(progn
  (alert msg)
  (mode_tile key 2)
)
     )
   )

   ;;-------------------------------------------------------------------;;

   (setq keys	 (writeDcl)
  tmp	 (car keys)
  tKeys	 (cadr keys)
  bKeys	 (caddr keys)
  dcl_id (load_dialog tmp)
  status 2
   )
   (while (< 1 status)
     (or (new_dialog "xdedit_l" dcl_id) (exit))
     (foreach k tKeys
(setq klst (gc:str2lst k "_"))
(set_tile k
	  (cond
	    ((wcmatch (caddr klst) "101#")
	     (gc:lst2str (mapcar 'rtos (cdr (nth (atoi (car klst)) xdata))) ",")
	    )
	    ((wcmatch (caddr klst) "104#") (rtos (cdr (nth (atoi (car klst)) xdata))))
	    ((wcmatch (caddr klst) "107#") (itoa (cdr (nth (atoi (car klst)) xdata))))
	    (T (cdr (nth (atoi (car klst)) xdata)))
	  )
)
(action_tile
  k
  (cond
    ((wcmatch (caddr klst) "101#")
     "(action $key (gc:toPoint $value) \"Requires a valid point\")"
    )
    ((wcmatch (caddr klst) "104#")
     "(action $key (distof $value) \"Requires a valid real number\")"
    )
    ((= (caddr klst) "1070")
     "(action $key (gc:toInt16 $value) \"Requires an integer between -32768 et 32767\")"
    )
    ((= (caddr klst) "1071")
     "(action $key (gc:toInt32 $value) \"Requires an integer between -2147483648 et 2147483647\")"
    )
    ((= (caddr klst) "1003")
     (vl-prin1-to-string
       '(if
	 (tblsearch "LAYER" $value)
	 (xdSubst $key $value)
	 (progn
	  (alert "Requires a valid layer name")
	  (mode_tile $key 2)
	 )
	)
     )
    )
    ((= (caddr klst) "1005")
     (vl-prin1-to-string
       '(if
	 (handent $value)
	 (xdSubst $key $value)
	 (progn
	  (alert "Requires a valid 'handle'")
	  (mode_tile $key 2)
	 )
	)
     )
    )
    ("(xdSubst $key $value)")
  )
)
     )
     (foreach k bKeys
(setq klst (gc:str2lst k "_"))
(action_tile
  k
  (strcat "(setq key $key) (done_dialog "
	  (cond
	    ((= (caddr klst) "1003") "3)")
	    ((= (caddr klst) "1005") "4)")
	    ((= (caddr klst) "1040") "5)")
	    ((= (caddr klst) "1041") "6)")
	    ((member (caddr klst) '("1010" "1011")) "7)")
	    ((member (caddr klst) '("1012" "1013")) "8)")
	  )
  )
)
     )
     (action_tile "cancel" "(done_dialog 0)")
     (action_tile "ok" "(done_dialog 1)")
     (setq status (start_dialog))
     (cond
((= status 3)
 (if (setq val (car (entsel "\nSelect an entity on the desired layer: ")))
   (xdSubst key (cdr (assoc 8 (entget val))))
 )
)
((= status 4)
 (if (setq val (car (entsel "\nSelect the entity for the desired 'handle': ")))
   (xdSubst key (cdr (assoc 5 (entget val))))
 )
)
((= status 5)
 (initget "Angle Distance")
 (setq opt
	(cond
	  ((getkword "\nChoose an option [Angle/Distance] <D>: "))
	  ("Distance")
	)
 )
 (if (= opt "Angle")
   (if (setq val (getangle "\nSpecify an angle: "))
     (xdSubst key val)
   )
   (if (setq val (getdist "\nSpecify an distance: "))
     (xdSubst key val)
   )
 )
)
((= status 6)
 (if (setq val (getdist "\nSpecify a distance "))
   (xdSubst key val)
 )
)
((= status 7)
 (if (setq val (getpoint "\nSpecify a point : "))
   (xdSubst key val)
 )
)
((= status 8)
 (if (setq val (gc:getVector))
   (xdSubst key val)
 )
)
     )
   )
   (unload_dialog dcl_id)
   (vl-file-delete tmp)
   status
 )

 ;;----------------------- fonction principale -----------------------;;

 (sssetfirst nil nil)
 (if (setq ent (car (entsel)))
   (if	(setq apps (mapcar 'car (setq xdata (cdr (assoc -3 (entget ent '("*")))))))
     (if (= 1 (length apps))
(setq appName (caar xdata)
      xdata   (cdar xdata)
)
(if (setq appName (gc:ListBox "Registered applications" nil (mapcar 'cons apps apps) 0))
  (setq xdata (cdr (assoc appName xdata)))
)
     )
   )
   (alert "This entity has no extended data")
 )
 (if (and xdata (= 1 (xdedit_lDlg)))
   (entmod (append (entget ent) (list (list -3 (cons appName xdata)))))
 )
 (princ)
)

;;----------------------------- routines -----------------------------;;

;; gc:str2lst
;; Transforme un chaine avec séparateur en liste de chaines
;;
;; Arguments
;; str : la chaine à transformer en liste
;; sep : le séparateur
(defun gc:str2lst (str sep / pos)
 (if (setq pos (vl-string-search sep str))
   (cons (substr str 1 pos)
  (gc:str2lst (substr str (+ (strlen sep) pos 1)) sep)
   )
   (list str)
 )
)

;;-------------------------------------------------------------------;;

;; gc:lst2str
;; Concatène une liste et un séparateur en une chaine
;;
;; Arguments
;; lst : la liste à transformer en chaine
;; sep : le séparateur
(defun gc:lst2str (lst sep)
 (if (cdr lst)
   (strcat (car lst)
    sep
    (gc:lst2str (cdr lst) sep)
   )
   (vl-princ-to-string (car lst))
 )
)

;;-------------------------------------------------------------------;;

;; gc:SubstAt
;; Remplace l'élément à l'indice dans la liste
;;
;; Arguments
;; ele : l'élément à remplacer
;; ind : l'indice
;; lst la liste
(defun gc:SubstAt (ele ind lst)
 (cond
   ((null lst) nil)
   ((zerop ind) (cons ele (cdr lst)))
   ((cons (car lst) (gc:SubstAt ele (1- ind) (cdr lst))))
 )
)

;;-------------------------------------------------------------------;;

;; gc:toInt16
;; Convertit une chaîne en un entier codé sur 16 bits (nil en cas d'echec)
;;
;; Argument
(defun gc:toInt16 (str / num)
 (if
   (and
     (setq num (distof str))
     (= num (fix num))
     (<= -32768 num 32767)
   )
    (fix num)
 )
)

;;-------------------------------------------------------------------;;

;; gc:toInt32
;; Convertit une chaîne en un entier codé sur 32 bits (nil en cas d'echec)
(defun gc:toInt32 (str / num)
 (if
   (and
     (setq num (distof str))
     (= num (fix num))
     (<= -2147483648 num 2147483647)
   )
    (fix num)
 )
)

;;-------------------------------------------------------------------;;

;; gc:toPoint
;; Convertit une chaîne en un point 3d (nil en cas d'echec)
(defun gc:toPoint (str / pt)
 (if (vl-every 'numberp (setq pt (mapcar 'distof (gc:str2lst str ","))))
   (cond
     ((= 2 (length pt)) (list (float (car pt)) (float (cadr pt)) 0.0))
     ((= 3 (length pt)) (mapcar 'float pt))
   )
 )
)

;;-------------------------------------------------------------------;;

;; gc:getVector
;; Retourne le vecteur spécifié
(defun gc:getVector (/ p1 p2)
 (setq	p1 (cond
     ((getpoint "\nSpecify the starting point <0,0,0>: "))
     ('(0. 0. 0.))
   )
 )
 (if (setq p2 (getpoint p1 "\nSpecify the end: "))
   (mapcar '- p2 p1)
 )
)

;;-------------------------------------------------------------------;;

;; gc:ListBox (gile)
;; Boite de dialogue permettant un ou plusieurs choix dans une liste
;;
;; Arguments
;; title : le titre de la boite de dialogue (chaîne)
;; msg ; message (chaîne), "" ou nil pour aucun
;; keylab : une liste d'association du type ((key1 . label1) (key2 . label2) ...)
;; flag : 0 = liste déroulante
;;        1 = liste choix unique
;;        2 = liste choix multipes
;;
;; Retour : la clé de l'option (flag = 0 ou 1) ou la liste des clés des options (flag = 2)
(defun gc:ListBox (title msg keylab flag / tmp file dcl_id choice)
 (setq	tmp  (vl-filename-mktemp "tmp.dcl")
file (open tmp "w")
 )
 (write-line
   (strcat "ListBox:dialog{label=\"" title "\";")
   file
 )
 (if (and msg (/= msg ""))
   (write-line (strcat ":text{label=\"" msg "\";}") file)
 )
 (write-line
   (cond
     ((= 0 flag) "spacer;:popup_list{key=\"lst\";")
     ((= 1 flag) "spacer;:list_box{key=\"lst\";")
     (T "spacer;:list_box{key=\"lst\";multiple_select=true;")
   )
   file
 )
 (write-line "}spacer;ok_cancel;}" file)
 (close file)
 (setq dcl_id (load_dialog tmp))
 (if (not (new_dialog "ListBox" dcl_id))
   (exit)
 )
 (start_list "lst")
 (mapcar 'add_list (mapcar 'cdr keylab))
 (end_list)
 (action_tile
   "accept"
   "(or (= (get_tile \"lst\") \"\")
   (if (= 2 flag) (progn
   (foreach n (str2lst (get_tile \"lst\") \" \")
   (setq choice (cons (nth (atoi n) (mapcar 'car keylab)) choice)))
   (setq choice (reverse choice)))
   (setq choice (nth (atoi (get_tile \"lst\")) (mapcar 'car keylab)))))
   (done_dialog)"
 )
 (start_dialog)
 (unload_dialog dcl_id)
 (vl-file-delete tmp)
 choice
)
(princ "\n   Type in command line: XDEDIT_L")
